Robotsystem from Robot Group Leipzig: OneLayerFFNN Class Reference

- Main Page
- Modules
- Namespaces
- Classes
- Files
- Directories
- Examples

- Class List
- Alphabetical List
- Class Hierarchy
- Class Members

# OneLayerFFNN Class Reference

`#include <onelayerffnn.h>`

Inheritance diagram for OneLayerFFNN:

[legend]
Collaboration diagram for OneLayerFFNN:

[legend]
List of all members.

## Detailed Description

simple one layer neural network with configurable activation function

Definition at line 7 of file onelayerffnn.h.

## Public Member Functions
| OneLayerFFNN (double eps, double factor_bias=0.1)
| Uses linear activation function.
| OneLayerFFNN (double eps, double factor_bias, ActivationFunction actfun, ActivationFunction dactfun)
virtual | ~OneLayerFFNN ()
virtual void | init (unsigned int inputDim, unsigned int outputDim)
| initialisation of the network with the given number of input and output units
virtual const matrix::Matrix | process (const matrix::Matrix &input) const
| passive processing of the input
virtual const matrix::Matrix | learn (const matrix::Matrix &input, const matrix::Matrix &nom_output, double learnRateFactor=1)
| performs learning and returns the network output before learning
virtual unsigned int | getInputDim () const
| returns the number of input neurons
virtual unsigned int | getOutputDim () const
| returns the number of output neurons
virtual const matrix::Matrix & | getWeights () const
virtual const matrix::Matrix & | getBias () const
virtual void | damp (double damping)
| damps the weights and the biases by multiplying (1-damping)
virtual paramkey | getName () const
| return the name of the object (with version number) Hint: { return "$ID$"; }
virtual paramval | getParam (const paramkey key) const
virtual bool | setParam (const paramkey key, paramval val)
virtual paramlist | getParamList () const
| The list of all parameters with there value as allocated lists.

## Constructor & Destructor Documentation

OneLayerFFNN | ( | double | eps,
|  | double | factor_bias = `0.1`
| ) | `[inline]`

  | Uses linear activation function. Parameters:
  | eps | learning rate
  | factor_bias | learning rate factor for bias learning
Definition at line 14 of file onelayerffnn.h.

OneLayerFFNN | ( | double | eps,
|  | double | factor_bias,
|  | ActivationFunction | actfun,
|  | ActivationFunction | dactfun
| ) | `[inline]`

  | Parameters:
  | eps | learning rate
  | factor_bias | learning rate factor for bias learning
  | actfun | callback activation function (see FeedForwardNN)
  | dactfun | callback for first derivative of the activation function
Definition at line 28 of file onelayerffnn.h.

virtual ~OneLayerFFNN | ( |  | ) | `[inline, virtual]`

| Definition at line 35 of file onelayerffnn.h.

## Member Function Documentation

virtual void damp | ( | double | damping | ) | `[inline, virtual]`

| damps the weights and the biases by multiplying (1-damping) Implements FeedForwardNN. Definition at line 61 of file onelayerffnn.h.

virtual const matrix::Matrix& getBias | ( |  | ) | const`[inline, virtual]`

| Definition at line 58 of file onelayerffnn.h.

virtual unsigned int getInputDim | ( |  | ) | const`[inline, virtual]`

| returns the number of input neurons Implements FeedForwardNN. Definition at line 49 of file onelayerffnn.h.

virtual paramkey getName | ( |  | ) | const`[inline, virtual]`

| return the name of the object (with version number) Hint: { return "$ID$"; } Reimplemented from Configurable. Definition at line 67 of file onelayerffnn.h.

virtual unsigned int getOutputDim | ( |  | ) | const`[inline, virtual]`

| returns the number of output neurons Implements FeedForwardNN. Definition at line 53 of file onelayerffnn.h.

virtual paramval getParam | ( | const paramkey | key | ) | const`[inline, virtual]`

| Definition at line 71 of file onelayerffnn.h.

virtual paramlist getParamList | ( |  | ) | const`[inline, virtual]`

| The list of all parameters with there value as allocated lists. Returns: list of key-value pairs Reimplemented from Configurable. Definition at line 83 of file onelayerffnn.h.

virtual const matrix::Matrix& getWeights | ( |  | ) | const`[inline, virtual]`

| Definition at line 57 of file onelayerffnn.h.

void init | ( | unsigned int | inputDim,
|  | unsigned int | outputDim
| ) | `[virtual]`

| initialisation of the network with the given number of input and output units Implements FeedForwardNN. Definition at line 7 of file onelayerffnn.cpp.

const Matrix learn | ( | const matrix::Matrix & | input,
|  | const matrix::Matrix & | nom_output,
|  | double | learnRateFactor = `1`
| ) | `[virtual]`

| performs learning and returns the network output before learning Implements FeedForwardNN. Definition at line 19 of file onelayerffnn.cpp.

const Matrix process | ( | const matrix::Matrix & | input | ) | const`[virtual]`

| passive processing of the input Implements FeedForwardNN. Definition at line 14 of file onelayerffnn.cpp.

virtual bool setParam | ( | const paramkey | key,
|  | paramval | val
| ) | `[inline, virtual]`

| Definition at line 76 of file onelayerffnn.h.